unit Prometheus.Client.Metrics;

interface

type

{ TMetricValidator }

  TMetricValidator = class sealed
  private const
    Pattern: string = '^[a-zA-Z_:][a-zA-Z0-9_:]*$';
  public
    class procedure CheckName(const AName: string);
  end;

implementation

uses
  System.RegularExpressions,
  System.SysUtils,
  Prometheus.Client.Resources;

{ TMetricValidator }

class procedure TMetricValidator.CheckName(const AName: string);
begin
  if Length(AName) <= 0 then
    raise EArgumentException.Create(StrErrEmptyMetricName);
  if not TRegEx.IsMatch(AName, Pattern) then
    raise EArgumentException.Create(StrErrInvalidMetricName);
end;

end.
