unit Prometheus.Client.Samples;

interface

uses
  Prometheus.Client.Labels, Prometheus.Client.Metrics;

type

{ TSample }

  TSample = record
    MetricName: string;
    LabelNames: TLabelNames;
    LabelValues: TArray<string>;
    TimeStamp: Int64;
    Value: Double;
    function HasLabels: Boolean;
    function HasTimeStamp: Boolean;
  end;

  PSample = ^TSample;

{ TMetricSamples }

  TMetricSamples = record
    MetricName: string;
    MetricHelp: string;
    MetricType: string;
    Samples: TArray<TSample>;
  end;

  PMetricSamples = ^TMetricSamples;

implementation

{ TSample }

function TSample.HasLabels: Boolean;
begin
  Result := (Length(LabelNames) > 0) and (Length(LabelValues) > 0);
end;

function TSample.HasTimeStamp: Boolean;
begin
  Result := TimeStamp > 0;
end;

end.
